// Server.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "soapH.h"
#include "GSN.nsmap"
#include <string>

using namespace std;

bool indentifyUser(string ID, string Password);

int main(int argc, char* argv[])
{
	struct soap soap;

	soap_init(&soap);	// must initilize

	int m = soap_bind(&soap, NULL, atoi("44444"), 100);	// port: 44444

	if( m < 0 )
	{
		soap_print_fault(&soap, stderr);
		exit(-1);
	}
	printf("Socket connection successful: master socket = %d\n", m);
	
	int s = 0;

	while( true )
	{
		s = soap_accept(&soap);
		printf("socket connection successful: slave socket = %d\n", s);

		if( s < 0 )
		{
			soap_print_fault(&soap, stderr);
			exit(-1);
		}
		soap_serve(&soap);
		soap_end(&soap);
	}
	
	return 0;
}

bool indentifyUser(string ID, string Password)
{
	if(ID == "root" && Password == "pass")
		return true;
	return false;
}

int gsnns__setAzimuth(struct soap* soap, char *ID, char *Password, int Antenna, double AzimuthInDegrees, double &SetValueInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		// control azimuth here
		SetValueInDegrees = 41.5;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getAzimuth(struct soap* soap, char *ID, char *Password, int Antenna, double &ValueInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		ValueInDegrees = 14.5;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__setElevation(struct soap* soap, char *ID, char *Password, int Antenna, double ElevationInDegrees, double &SetValueInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		// control elevation here
		SetValueInDegrees = 54.9;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getElevation(struct soap* soap, char *ID, char *Password, int Antenna, double &ValueInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		ValueInDegrees = 23.4;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__setFrequency(struct soap* soap, char *ID, char *Password, int Band, double FrequencyInMHz, double &SetValueInMHz)
{
	if(indentifyUser(ID, Password))
	{
		// control frequency here
		SetValueInMHz = 144.98546;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getFrequency(struct soap* soap, char *ID, char *Password, int Band, double &ValueInMHz)
{
	if(indentifyUser(ID, Password))
	{
		ValueInMHz = 144.28546;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__setMode(struct soap* soap, char *ID, char *Password, char *Mode, char *&SetMode)
{
	if(indentifyUser(ID, Password))
	{
		// control radio mode & TNC modulation here
		SetMode = "CW";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getMode(struct soap* soap, char *ID, char *Password, char *&Mode)
{
	if(indentifyUser(ID, Password))
	{
		Mode = "FM";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__setRadioMode(struct soap* soap, char *ID, char *Password, char *Mode, char *&SetMode)
{
	if(indentifyUser(ID, Password))
	{
		// control radio mode here
		SetMode = "AM";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getRadioMode(struct soap* soap, char *ID, char *Password, char *&Mode)
{
	if(indentifyUser(ID, Password))
	{
		Mode = "FM";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__setTNCMode(struct soap* soap, char *ID, char *Password, char *Mode, char *&SetMode)
{
	if(indentifyUser(ID, Password))
	{
		// control TNC modulation here
		SetMode = "FSK1200";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getTNCMode(struct soap* soap, char *ID, char *Password, char *&Mode)
{
	if(indentifyUser(ID, Password))
	{
		Mode = "GMSK9600";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getStatus(struct soap* soap, char *ID, char *Password, char *&Status)
{
	if(indentifyUser(ID, Password))
	{
		Status = "aveilable";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getName(struct soap* soap, char *ID, char *Password, char *&Name)
{
	if(indentifyUser(ID, Password))
	{
		Name = "Tokyo Institute of Technology";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getCountry(struct soap* soap, char *ID, char *Password, char *&Country)
{
	if(indentifyUser(ID, Password))
	{
		Country = "Japan";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getLongitude(struct soap* soap, char *ID, char *Password, double &LongitudeInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		LongitudeInDegrees = 139.684885;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getLatitude(struct soap* soap, char *ID, char *Password, double &LatitudeInDegrees)
{
	if(indentifyUser(ID, Password))
	{
		LatitudeInDegrees = 35.601174;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getAltitude(struct soap* soap, char *ID, char *Password, double &AltitudeInMeter)
{
	if(indentifyUser(ID, Password))
	{
		AltitudeInMeter = 110;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getUTCOffset(struct soap* soap, char *ID, char *Password, double &UTCOffsetInHour)
{
	if(indentifyUser(ID, Password))
	{
		UTCOffsetInHour = 9;	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getStart(struct soap* soap, char *ID, char *Password, char *&Result)
{
	if(indentifyUser(ID, Password))
	{
		Result = "OK";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}

int gsnns__getEnd(struct soap* soap, char *ID, char *Password, char *&Result)
{
	if(indentifyUser(ID, Password))
	{
		Result = "OK";	// dummy
		return SOAP_OK;
	}
	else
	{
		soap->error = soap_receiver_fault(soap, "error", "detail");
		return SOAP_FAULT;
	}
}