/***************************************************************************
             gsnservices.h  -  Ground Station Network Services
                             -------------------
    last updated		: Fri Jan 10 2003
    author				: (C) 2003 by Naoki MIYASHITA
    email				: miyashita@ieee.org
 ***************************************************************************/
    
// coordinate XML Schema Part 2: Datatypes http://www.w3.org/TR/xmlschema-2/
typedef	bool	xsd__boolean;	// encode xsd boolean value as the xsd:boolean schema type
typedef char	xsd__byte;		// encode xsd byte value as the xsd:byte schema type
typedef	char*	xsd__string;	// encode xsd string value as the xsd:string schema type
typedef	int		xsd__int;		// encode xsd int value as the xsd:int schema type
typedef	float	xsd__float;		// encode xsd float value as the xsd:float schema type
typedef	double	xsd__double;	// encode xsd double value as the xsd:double schema type

//gsoap gsnns service name: GSN 
//gsoap gsnns service location: http://localhost:44444
//gsoap gsnns service namespace: http://www.unisec.jp/gsn

//gsoap gsnns service method-documentation: setAzimuth This method is setAzimuth
//gsoap gsnns service method-action: setAzimuth "http://localhost:44444/setAzimuth"
int gsnns__setAzimuth(xsd__string ID, xsd__string Password, xsd__int Antenna, xsd__double AzimuthInDegrees, xsd__double &SetValueInDegrees);

//gsoap gsnns service method-documentation: getAzimuth This method is getAzimuth
//gsoap gsnns service method-action: getAzimuth "http://localhost:44444/getAzimuth"
int gsnns__getAzimuth(xsd__string ID, xsd__string Password, xsd__int Antenna, xsd__double &ValueInDegrees);

//gsoap gsnns service method-documentation: setElevation This method is setElevation
//gsoap gsnns service method-action: setElevation "http://localhost:44444/setElevation"
int gsnns__setElevation(xsd__string ID, xsd__string Password, xsd__int Antenna, xsd__double ElevationInDegrees, xsd__double &SetValueInDegrees);

//gsoap gsnns service method-documentation: getElevation This method is getElevation
//gsoap gsnns service method-action: getElevation "http://localhost:44444/getElevation"
int gsnns__getElevation(xsd__string ID, xsd__string Password, xsd__int Antenna, xsd__double &ValueInDegrees);

//gsoap gsnns service method-documentation: setFrequency This method is setFrequency
//gsoap gsnns service method-action: setFrequency "http://localhost:44444/setFrequency"
int gsnns__setFrequency(xsd__string ID, xsd__string Password, xsd__int Band, xsd__double FrequencyInMHz, xsd__double &SetValueInMHz);

//gsoap gsnns service method-documentation: getFrequency This method is getFrequency
//gsoap gsnns service method-action: getFrequency "http://localhost:44444/getFrequency"
int gsnns__getFrequency(xsd__string ID, xsd__string Password, xsd__int Band, xsd__double &ValueInMHz);

//gsoap gsnns service method-documentation: setMode This method is setMode
//gsoap gsnns service method-action: setMode "http://localhost:44444/setMode"
int gsnns__setMode(xsd__string ID, xsd__string Password, xsd__string Mode, xsd__string &SetMode);

//gsoap gsnns service method-documentation: getMode This method is getMode
//gsoap gsnns service method-action: getMode "http://localhost:44444/getMode"
int gsnns__getMode(xsd__string ID, xsd__string Password, xsd__string &Mode);

//gsoap gsnns service method-documentation: setRadioMode This method is setRadioMode
//gsoap gsnns service method-action: setRadioMode "http://localhost:44444/setRadioMode"
int gsnns__setRadioMode(xsd__string ID, xsd__string Password, xsd__string Mode, xsd__string &SetMode);

//gsoap gsnns service method-documentation: getRadioMode This method is getRadioMode
//gsoap gsnns service method-action: getRadioMode "http://localhost:44444/getRadioMode"
int gsnns__getRadioMode(xsd__string ID, xsd__string Password, xsd__string &Mode);

//gsoap gsnns service method-documentation: setTNCMode This method is setTNCMode
//gsoap gsnns service method-action: setTNCMode "http://localhost:44444/setTNCMode"
int gsnns__setTNCMode(xsd__string ID, xsd__string Password, xsd__string Mode, xsd__string &SetMode);

//gsoap gsnns service method-documentation: getTNCMode This method is getTNCMode
//gsoap gsnns service method-action: getTNCMode "http://localhost:44444/getTNCMode"
int gsnns__getTNCMode(xsd__string ID, xsd__string Password, xsd__string &Mode);

//gsoap gsnns service method-documentation: getStatus This method is getStatus
//gsoap gsnns service method-action: getStatus "http://localhost:44444/getStatus"
int gsnns__getStatus(xsd__string ID, xsd__string Password, xsd__string &Status);

//gsoap gsnns service method-documentation: getName This method is getName
//gsoap gsnns service method-action: getName "http://localhost:44444/getName"
int gsnns__getName(xsd__string ID, xsd__string Password, xsd__string &Name);

//gsoap gsnns service method-documentation: getCountry This method is getCountry
//gsoap gsnns service method-action: getCountry "http://localhost:44444/getCountry"
int gsnns__getCountry(xsd__string ID, xsd__string Password, xsd__string &Country);

//gsoap gsnns service method-documentation: getLongitude This method is getLongitude
//gsoap gsnns service method-action: getLongitude "http://localhost:44444/getLongitude"
int gsnns__getLongitude(xsd__string ID, xsd__string Password, xsd__double &LongitudeInDegrees);

//gsoap gsnns service method-documentation: getLatitude This method is getLatitude
//gsoap gsnns service method-action: getLatitude "http://localhost:44444/getLatitude"
int gsnns__getLatitude(xsd__string ID, xsd__string Password, xsd__double &LatitudeInDegrees);

//gsoap gsnns service method-documentation: getAltitude This method is getAltitude
//gsoap gsnns service method-action: getAltitude "http://localhost:44444/getAltitude"
int gsnns__getAltitude(xsd__string ID, xsd__string Password, xsd__double &AltitudeInMeter);

//gsoap gsnns service method-documentation: getUTCOffset This method is getUTCOffset
//gsoap gsnns service method-action: getUTCOffset "http://localhost:44444/getUTCOffset"
int gsnns__getUTCOffset(xsd__string ID, xsd__string Password, xsd__double &UTCOffsetInHour);

//gsoap gsnns service method-documentation: getStart This method is getStart
//gsoap gsnns service method-action: getStart "http://localhost:44444/getStart"
int gsnns__getStart(xsd__string ID, xsd__string Password, xsd__string &Result);

//gsoap gsnns service method-documentation: getEnd This method is getEnd
//gsoap gsnns service method-action: getEnd "http://localhost:44444/getEnd"
int gsnns__getEnd(xsd__string ID, xsd__string Password, xsd__string &Result);

